/* $Id: lapack.nw,v 1.5 2004/06/22 09:30:18 ohl Exp $ */

/* Copyright (C) 2002-2004 by Thorsten Ohl <ohl@physik.uni-wuerzburg.de> et al.
   and others
  
   O'Mega is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by 
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
  
   O'Mega is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
#include <assert.h>
#include <caml/bigarray.h>
extern void eigenv_ (int *n, double *a, double *w,
                     int *lwork, double *work, int *info);
value
eigenv_glue (value a, value w, value work)
{
  int n, lwork, info;
  assert (Bigarray_val(a)->num_dims == 2);
  assert (Bigarray_val(a)->dim[0] == Bigarray_val(a)->dim[1]);
  assert ((Bigarray_val(a)->flags & BIGARRAY_KIND_MASK) == BIGARRAY_FLOAT64);
  assert (Bigarray_val(w)->num_dims == 1);
  assert ((Bigarray_val(w)->flags & BIGARRAY_KIND_MASK) == BIGARRAY_FLOAT64);
  assert (Bigarray_val(work)->num_dims == 1);
  assert ((Bigarray_val(work)->flags & BIGARRAY_KIND_MASK) == BIGARRAY_FLOAT64);
  n = Bigarray_val(a)->dim[0];
  lwork = Bigarray_val(work)->dim[0];
  info = 0;
  eigenv_ (&n, Data_bigarray_val (a), Data_bigarray_val (w),
           &lwork, Data_bigarray_val(work), &info);
  return Val_int (info);
}
