! $Id: omegalib.nw,v 1.116 2004/04/29 18:08:46 ohl Exp $
!
! Copyright (C) 2000-2002 by Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
! and others
!
! O'Mega is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! O'Mega is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
module omega_tensor_polarizations
  use omega_kinds
  use omega_constants
  use omega_vectors
  use omega_tensors
  use omega_polarizations
  implicit none
  private
  public :: eps2
  integer, parameter, public :: omega_tensor_pols_2003_03_A = 0
contains
  pure function eps2 (m, k, s) result (t)
    type(tensor) :: t
    real(kind=omega_prec), intent(in) :: m
    type(momentum), intent(in) :: k
    integer, intent(in) :: s
    type(vector) :: ep, em, e0
    t%t = 0
    select case (s)
    case (2)
       ep = eps (m, k, 1)
       t = outer_product (ep, ep)
    case (1)
       ep = eps (m, k, 1)
       e0 = eps (m, k, 0)
       t = (1 / sqrt (2.0_omega_prec)) &
            * (outer_product (ep, e0) + outer_product (e0, ep))
    case (0)
       ep = eps (m, k, 1)
       e0 = eps (m, k, 0)
       em = eps (m, k, -1)
       t = (1 / sqrt (2.0_omega_prec)) &
             * (outer_product (ep, em) + outer_product (em, ep) &
                 - 2 * outer_product (em, ep))
    case (-1)
       e0 = eps (m, k, 0)
       em = eps (m, k, -1)
       t = (1 / sqrt (2.0_omega_prec)) &
             * (outer_product (em, e0) + outer_product (e0, em))
    case (-2)
       em = eps (m, k, -1)
       t = outer_product (em, em)
    end select
  end function eps2
end module omega_tensor_polarizations
