(* $Id: target.mli,v 1.14 2004/06/22 09:30:18 ohl Exp $ *)
(* Copyright (C) 2000-2004 by Thorsten Ohl <ohl@physik.uni-wuerzburg.de> et al.
   O'Mega is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by 
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
   O'Mega is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  *)  

module type T =
  sig
    type amplitude
    type amplitudes

    val options : Options.t
    type diagnostic = All | Arguments | Helicities | Momenta | Gauge

(* Format the amplitude as a sequence of strings. *)
    val amplitude_to_channel : out_channel ->
      (diagnostic * bool) list -> amplitude -> unit

    val amplitudes_to_channel : out_channel ->
      (diagnostic * bool) list -> amplitudes -> unit

    val parameters_to_channel : out_channel -> unit

    val rcs_list : RCS.t list
  end

module type Maker =
    functor (F : Fusion.T) -> functor (MF : Fusion.MultiMaker) ->
      functor (M : Model.T with type flavor = F.flavor
      and type constant = F.constant) ->
        T with type amplitude = F.amplitude
        and type amplitudes = MF(F).amplitudes

(*i
 *  Local Variables:
 *  mode:caml
 *  indent-tabs-mode:nil
 *  page-delimiter:"^(\\* .*\n"
 *  End:
i*)
